VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Thread"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Dim Wavepos As Long
Dim Divisions As Long
Dim Length As Long
Dim Angles() As Double
Dim FramesPerSeg As Long
Dim State As Byte
Public AttachedTo As Long ' the node of the spine it is attached to
Public WaveRunning As Boolean

Dim BoneStrings() As String
Dim BoneNums() As Long
Const TENT = 0 ' if wave looks like --/\--
Const HOUSE = 1 ' if wave looks like --/-\--
Const GONE = 2 ' if wave looks like ------
Sub Init(Divisionz As Long, Lengthz As Long, Speed As Long)
Divisions = Divisionz
Length = Lengthz
FramesPerSeg = Speed

ReDim Angles(Divisions)
ReDim BoneStrings(Divisions)
ReDim BoneNums(Divisions)
For x = 0 To Divisions
    BoneNums(x) = CurBone
    CurBone = CurBone + 1
Next x
End Sub
Sub StartWave(frames As Long)
For x = 0 To UBound(Angles)
    Angles(x) = 0
    BoneStrings(x) = "jointangle { " & Chr(34) & " bone " & BoneNums(x) & Chr(34) & " " & Chr(34) & "X" & Chr(34) & " track {"
Next x
Wavepos = 0
FramesPerSeg = 0
WaveRunning = True


End Sub
Sub RunWave(ThisFrame As Long, Speed As Long)

Static LastFrameMove As Long
'Dim BackAngles() As Long
'ReDim BackAngles(UBound(Angles))

'For x = 0 To UBound(Angles)
'    BackAngles(x) = Angles(x) ' this creates a backup of the angles, in case we need them
'Next x

Dim ToBeAdded As String

If ThisFrame - LastFrameMove >= Speed Then
    If Wavepos + 0 < UBound(Angles) Then Angles(Wavepos) = 0
    If Wavepos + 1 < UBound(Angles) Then Angles(Wavepos + 1) = 20
    If Wavepos + 2 < UBound(Angles) Then Angles(Wavepos + 2) = -40
    If Wavepos + 3 < UBound(Angles) Then Angles(Wavepos + 3) = 20
    If Wavepos + 4 < UBound(Angles) Then Angles(Wavepos + 4) = 0
    
    For x = Wavepos To Wavepos + 4
        If x < UBound(Angles) Then ToBeAdded = " floatkey { " & ThisFrame & " " & Angles(x) & " " & Chr(34) & "?" & Chr(34) & "}"
        If x < UBound(Angles) Then BoneStrings(x) = BoneStrings(x) & ToBeAdded
    Next x
    Wavepos = Wavepos + 1
    LastFrameMove = ThisFrame
    
End If




End Sub
Sub WriteAnim()
For x = 0 To UBound(Angles)
    BoneStrings(x) = BoneStrings(x) & "}}"
    Text.WriteLine BoneStrings(x)
Next x


End Sub

Sub WriteThread(OtherDir As Boolean)
'bone { " bone  1"
' length { 20 }         structure of bone code
'dof { "X"  0  0  0
'        unlimited { }
'}
' next bone open bracket
' end brackets for all bones


For x = 0 To UBound(Angles)
    Text.WriteLine "bone { " & Chr(34) & " bone " & BoneNums(x) & Chr(34)
    
    
    Text.WriteLine "length { " & Length & " }"
    If x = 0 Then
        If OtherDir = False Then Text.WriteLine "orientation { (0 0 -0.70711 -0.70711) }"
        If OtherDir = True Then Text.WriteLine "orientation { (0 0 0.70711 -0.70711) }"
    End If
    Text.WriteLine "influence { 0.25000 3 14 0.75000 3 14}"
    Text.WriteLine "dof { " & Chr(34) & "X" & Chr(34) & "  0  0  0"
    Text.WriteLine "unlimited { }"
    Text.WriteLine "}"

Next x
For x = 0 To UBound(Angles)
    Text.WriteLine "}"
Next x

End Sub
Sub WriteWeights(WhoAmI As Integer)
End Sub
